unit operands;

interface
type
 TOperand = class
   function add(op:TOperand):TOperand;
   function multiply(op:TOperand):TOperand;
   procedure display;
 end;

 TReal = class (TOperand)
  value:real;
  constructor init(value:real);
  function add(op:TOperand):TOperand;
  function multiply(op:TOperand):TOperand;
  procedure display;
 end;

 TComplex = class (TOperand)
  re,im:real;
  constructor init(re,im:real);
  function add(op:TOperand):TOperand;
  function multiply(op:TOperand):TOperand;
  procedure display;
 end;


implementation


{ TOperand }

function TOperand.add(op: TOperand): TOperand;
begin
 add := TOperand.Create;
end;

procedure TOperand.display;
begin

end;

function TOperand.multiply(op: TOperand): TOperand;
begin
 multiply := TOperand.Create;
end;

{ TReal }

constructor TReal.init(value: real);
begin
 self.value := value;
end;

function TReal.add(op: TOperand): TOperand;
begin
 if op is TReal then
  add := TReal.init(value + (op as TReal).value)
 else
  add := TComplex.init(value + (Op as TComplex).re, (Op as TComplex).im);
end;

function TReal.multiply(op: TOperand): TOperand;
var cop:TComplex;
begin
 if op is TReal then
  multiply := TReal.init(value * (Op as TReal).value)
 else
 begin
  cop := op as TComplex;
  multiply := TComplex.init(value * cop.re, value * cop.im);
 end;
end;

procedure TReal.display;
begin
 writeln(value:0:5);

end;

{ TComplex }

constructor TComplex.init(re, im: real);
begin
 self.re := re;
 self.im := im;
end;

function TComplex.multiply(op: TOperand): TOperand;
var cop:TComplex;
begin
 if op is TComplex then
 begin
  cop:= op as TComplex;
  multiply := TComplex.init(re * cop.re - im * cop.im,
                            re * cop.im + cop.re * im);
 end
 else multiply := (op as TReal).multiply(self);

end;

function TComplex.add(op: TOperand): TOperand;
var cop:TComplex;
begin
 if op is TComplex then
 begin
  cop:=op as TComplex;
  add:=TComplex.init(re + cop.re, im + cop.im);
 end
 else add := (op as TReal).add(self);
end;

procedure TComplex.display;
begin
 writeln(re:0:5,' + ',im:0:5,' * i');
end;


end.
 